var video;

var scene, camera, renderer;
var rt1, rt2;
var rtSwitch = true;
var videoTexture, videoMaterial;
var vidWidth, vidHeight;

var stats;

function init() {
  //statsInit();
  // webCamInit -> setUp -> start animate
  webCamInit();
}

function setup() {

  // Three.js basics
  scene = new THREE.Scene();
  camera = new THREE.OrthographicCamera(vidWidth/-2, vidWidth/2, vidHeight/2, vidHeight/-2, 1, 2000);
  camera.position.z = 500;  // ã‚«ãƒ¡ãƒ©ã® near/far ã‚¯ãƒªãƒƒãƒ”ãƒ³ã‚°ã¨åˆã‚ã›ã¦è¨­å®šã™ã‚‹

  // renderer = new THREE.WebGLRenderer({ preserveDrawingBuffer: true });
  renderer = new THREE.WebGLRenderer({});
  renderer.setSize(vidWidth, vidHeight);
  // renderer.autoClearColor = false

  gl = renderer.getContext();

  if ( !gl.getExtension( "OES_texture_float" )) {
    alert( "No OES_texture_float support for float textures!" );
    return;
  }

  // RTT
  rt1 = new THREE.WebGLRenderTarget( vidWidth, vidHeight, { minFilter: THREE.LinearFilter, magFilter: THREE.NearestFilter, format: THREE.RGBFormat, type: THREE.FloatType }  );
  rt2 = new THREE.WebGLRenderTarget( vidWidth, vidHeight, { minFilter: THREE.LinearFilter, magFilter: THREE.NearestFilter, format: THREE.RGBFormat, type: THREE.FloatType }  );

  checkVersion(renderer);
  document.body.appendChild(renderer.domElement);

  videoTexture = new THREE.Texture(video);  // ãªã‚“ã¨ã“ã‚Œã ã‘ã§ãƒ†ã‚¯ã‚¹ãƒãƒ£ã¨ã—ã¦ä½¿ãˆã‚‹ï¼
  videoTexture.minFilter = THREE.LinearFilter;
  videoTexture.magFilter = THREE.LinearFilter;
  videoTexture.format = THREE.RGBAFormat;

  videoMaterial = new THREE.ShaderMaterial(THREE.BlendShader);
  videoMaterial.uniforms['tDiffuse1'].value = videoTexture;
  videoMaterial.uniforms['tDiffuse2'].value = null;
  videoMaterial.uniforms['mixRatio'].value = 0.0;

  var planeGeometry = new THREE.PlaneBufferGeometry( vidWidth, vidHeight, 1, 1 );
  var plane = new THREE.Mesh( planeGeometry, videoMaterial );  // å¹³é¢ã«æ›¸ãè¾¼ã‚€
  plane.position.z = 0;

  scene.add(plane);

  console.log("scene setupped");

  animate();
}

function animate() {
  if(video.readyState === video.HAVE_ENOUGH_DATA) {

    if(videoTexture) videoTexture.needsUpdate = true;

    if(rtSwitch) renderer.render(scene, camera, rt2);
    else renderer.render(scene, camera, rt1);
    renderer.render(scene, camera);

    if(rtSwitch) videoMaterial.uniforms['tDiffuse2'].value = rt2;
    else videoMaterial.uniforms['tDiffuse2'].value = rt1;
    rtSwitch = !rtSwitch;

    // videoMaterial.needsUpdate = true;
    // (ä¸è¦) ShadedMaterial ã® uniform å¤‰æ•°ã¯ã€å¤‰æ›´ãŒè‡ªå‹•çš„ã«åæ˜ ã•ã‚Œã‚‹ã€ã‚‰ã—ã„
  }

  //stats.update();

  // loop
  requestAnimationFrame(animate);
  // setTimeout( function() {
  //   requestAnimationFrame(animate);
  // }, 1000/30);
}

function changeMixRatio( element ) {
  var ratio = Number(element.value);
  // var _ratio = element.value;
  console.log(ratio);
  if(ratio == 0.7) videoMaterial.uniforms['mixRatio'].value = 0;
  else videoMaterial.uniforms['mixRatio'].value = ratio;

}

function statsInit() {
  stats = new Stats();
  stats.domElement.style.position = 'absolute';
  stats.domElement.style.bottom = '0px';
  stats.domElement.style.zIndex = 100;
  document.body.appendChild( stats.domElement );
}

function webCamInit() {
  navigator.getUserMedia = navigator.getUserMedia || navigator.webkitGetUserMedia || window.navigator.mozGetUserMedia;
  window.URL = window.URL || window.webkitURL;

  video = document.getElementById('video');
  video.autoplay = true;  // ã“ã‚Œã‚’å¤–ã™ã¨ã€ã‚¹ã‚¿ãƒ¼ãƒˆæ™‚ã®æ˜ åƒã§åœæ­¢ã—ã¾ã™
  var option = {
    video: { mandatory:{ minWidth: 1280 } }, // firefoxã ã¨å¤±æ•—ã™ã‚‹
    audio: false
  }
  // var option = {video: true};

  // 1st try FullHD
  navigator.getUserMedia(option,
    function(stream) { // for success case
      video.src = window.URL.createObjectURL(stream);  // videoã‚¿ã‚°ã«ã‚¹ãƒˆãƒªãƒ¼ãƒ ã‚’æµã—è¾¼ã‚€
    },
    function(err) { // for error case
      console.log(err);
    }
  );

  video.addEventListener('play', function() {
    // Chromeã¯å•é¡Œç„¡ã„ãŒã€Firefoxã ã¨ã€'loadeddata' ã‚¤ãƒ™ãƒ³ãƒˆã§videoWidthã‚‰ãŒåŸ‹ã¾ã£ã¦ã„ãªã„ã®ã§ã€å€¤ãŒå¾—ã‚‰ã‚Œã‚‹ã¾ã§å¾…æ©Ÿ
    (function getVideoResolution() {
      vidWidth = video.videoWidth;
      vidHeight = video.videoHeight;
      if(vidWidth != 0) {
        console.log("video width: " + vidWidth + " height: " + vidHeight);
        setup();
      } else {
        setTimeout(getVideoResolution, 250);
      }
    })();
  });
}

function checkVersion(_renderer) {
  var _gl = _renderer.context;
  console.log( _gl.getParameter(_gl.VERSION) );
  console.log( _gl.getParameter(_gl.SHADING_LANGUAGE_VERSION) );
}

// start on load.
window.onload = init;
