var vidWidth, vidHeight;
var THREE = S.THREE;
var rt1, rt2, rt3;
var videoTexture;
var video;
var videoMaterial;

function init( elem, isInit ) {
  if ( isInit ) return;

    navigator.getUserMedia = navigator.getUserMedia || navigator.webkitGetUserMedia || window.navigator.mozGetUserMedia;
    window.URL = window.URL || window.webkitURL;

    video = document.getElementById('video');
    video.autoplay = true;  // ã“ã‚Œã‚’å¤–ã™ã¨ã€ã‚¹ã‚¿ãƒ¼ãƒˆæ™‚ã®æ˜ åƒã§åœæ­¢ã—ã¾ã™
    var option = {
      video: { mandatory:{ minWidth: 1280 } }, // firefoxã ã¨å¤±æ•—ã™ã‚‹
      audio: false
    }
    // var option = {video: true};

    // 1st try FullHD
    navigator.getUserMedia(option,
      function(stream) { // for success case
        video.src = window.URL.createObjectURL(stream);  // videoã‚¿ã‚°ã«ã‚¹ãƒˆãƒªãƒ¼ãƒ ã‚’æµã—è¾¼ã‚€
      },
      function(err) { // for error case
        console.log(err);
      }
    );

    video.addEventListener('play', function() {
      // Chromeã¯å•é¡Œç„¡ã„ãŒã€Firefoxã ã¨ã€'loadeddata' ã‚¤ãƒ™ãƒ³ãƒˆã§videoWidthã‚‰ãŒåŸ‹ã¾ã£ã¦ã„ãªã„ã®ã§ã€å€¤ãŒå¾—ã‚‰ã‚Œã‚‹ã¾ã§å¾…æ©Ÿ
      (function getVideoResolution() {
        vidWidth = video.videoWidth;
        vidHeight = video.videoHeight;
        if(vidWidth != 0) {
          console.log("video width: " + vidWidth + " height: " + vidHeight);
          setSphere( elem );
        } else {
          setTimeout(getVideoResolution, 250);
        }
      })();
    });
};

function setSphere( rdr ) {


  var scene = S.document.getElementById( "scene" ).coreObject;
  var camera = new THREE.OrthographicCamera(vidWidth/-2, vidWidth/2, vidHeight/2, vidHeight/-2, 1, 2000);
  camera.position.z = 500;


  var renderer = rdr.coreObject;
  var gl = renderer.getContext();
  if ( !gl.getExtension( "OES_texture_float" )) {
    alert( "No OES_texture_float support for float textures!" );
    return;
  }
  // RTT
  rt1 = new THREE.WebGLRenderTarget( vidWidth, vidHeight, { minFilter: THREE.LinearFilter, magFilter: THREE.NearestFilter, format: THREE.RGBFormat, type: THREE.FloatType }  );
  rt2 = new THREE.WebGLRenderTarget( vidWidth, vidHeight, { minFilter: THREE.LinearFilter, magFilter: THREE.NearestFilter, format: THREE.RGBFormat, type: THREE.FloatType }  );
  rt3 = new THREE.WebGLRenderTarget( vidWidth, vidHeight, { minFilter: THREE.LinearFilter, magFilter: THREE.NearestFilter, format: THREE.RGBFormat, type: THREE.FloatType }  );

  videoTexture = new THREE.Texture(video);
  videoTexture.minFilter = THREE.LinearFilter;
  videoTexture.magFilter = THREE.LinearFilter;
  videoTexture.format = THREE.RGBAFormat;

  videoMaterial = new THREE.ShaderMaterial(THREE.BlendShader);
  videoMaterial.uniforms['tDiffuse1'].value = videoTexture;
  videoMaterial.uniforms['tDiffuse2'].value = null;
  videoMaterial.uniforms['mixRatio'].value = 0.0;

  //videoMaterial.uniforms['tVideo'].value = videoTexture;
  //videoMaterial.uniforms['maxDiff'].value = .5;

  var planeGeometry = new THREE.PlaneBufferGeometry( vidWidth, vidHeight, 1, 1 );
  var plane = new THREE.Mesh( planeGeometry, videoMaterial );
  plane.position.z = 400;

  scene.add(plane);

  var geometry = new THREE.SphereGeometry(100, 32, 32, 0);
  var faceVertexUvs = geometry.faceVertexUvs[ 0 ];
  for ( i = 0; i < faceVertexUvs.length; i++ ) {
    var uvs = faceVertexUvs[ i ];
    var face = geometry.faces[ i ];
    for ( var j = 0; j < 3; j ++ ) {
      var x = face.vertexNormals[ j ].x;
      var y = face.vertexNormals[ j ].y;
      var z = face.vertexNormals[ j ].z;

      if (i < faceVertexUvs.length / 2) {
        var correction = (x == 0 && z == 0) ? 1 : (Math.acos(y) / Math.sqrt(x * x + z * z)) * (2 / Math.PI);
        // uvs[ j ].x = x * (423 / 1920) * correction + (480 / 1920);
        // uvs[ j ].y = z * (423 / 1080) * correction + (600 / 1080);
        uvs[ j ].x = x * (428 / 1920) * correction + (480 / 1920);
        uvs[ j ].y = z * (428 / 1080) * correction + (600 / 1080);

      } else {
        var correction = ( x == 0 && z == 0) ? 1 : (Math.acos(-y) / Math.sqrt(x * x + z * z)) * (2 / Math.PI);
        // uvs[ j ].x = -1 * x * (423 / 1920) * correction + (1440 / 1920);
        // uvs[ j ].y = z * (423 / 1080) * correction + (600 / 1080);
        uvs[ j ].x = -1 * x * (428 / 1920) * correction + (1440 / 1920);
        uvs[ j ].y = z * (428 / 1080) * correction + (600 / 1080);
      }
    }
  }

  var mesh = new THREE.Mesh( geometry, videoMaterial );

  mesh.scale.x = -1;
  mesh.rotation.z = Math.PI / 2;
  S.document.getElementById( "target" ).coreObject.add( mesh );

  document.getElementById( "mixRatioInput" ).addEventListener( "input", function( element ) {
    var ratio = Number(this.value);
    // var _ratio = element.value;
    console.log(ratio);
    if(ratio == 0.7) videoMaterial.uniforms['mixRatio'].value = 0;
    else videoMaterial.uniforms['mixRatio'].value = ratio;

  }, false );

  var rtSwitch = true;
  S.update( function() {
    if(video.readyState !== video.HAVE_ENOUGH_DATA) return;
    if(videoTexture) videoTexture.needsUpdate = true;

    if(rtSwitch) videoMaterial.uniforms['tDiffuse2'].value = rt2;
    else videoMaterial.uniforms['tDiffuse2'].value = rt1;
    rtSwitch = !rtSwitch;

    if(rtSwitch) renderer.render(scene, camera, rt2);
    else renderer.render(scene, camera, rt1);

    renderer.render( scene, camera, rt3 );

  });
};

S( function( m ) {
	var App = {
		controller: function() {
			return {
				camStyle: { pos: [ 0, -5, 8 ] },
			};
		},
		view: function( ctrl ) {
			return <scene id="scene">
        <obj id="target"/>
				<cam id="mainCam" style={ctrl.camStyle}>
				    <light init={{ type: "Dir" }} style={{ pos: [0, 10,10 ] }}/>
				</cam>
				<light init={{ type: "Amb" }}/>
			</scene>;
		}
	};

	m.mount( S.document.body, App );
	m.render( S.document.head,
		<rdr init={{ frame: "#solufa", antialias: true, preserveDrawingBuffer: false }} config={ init }>
			<OrbitVp cam="#mainCam"/>
		</rdr>
	);
});
