S( function( m ) {
  var video = document.createElement( "video" );
  getWebCam( video );

  var App = {
		controller: function() {
			return {
        init: function( txr, elem, isInit ) {
          if ( isInit ) return;

        },
				geo: {
					type: "SphereBuffer",
					value: [ 300, 64, 64 ]
				},
				mtl: {
					type: "MeshBasic",
					value: {
            map: {
              type: "video",
              src: video
            }
          }
				},
        sphereStyle: { scaleX: -1 },
				camStyle: { posZ: 5 }
			};
		},
    view: function( ctrl ) {
			return {tag: "scene", attrs: {config: ctrl.init.bind( null, ctrl.mtl.value.map) }, children: [
				{tag: "mesh", attrs: {geo: ctrl.geo, mtl: ctrl.mtl, style: ctrl.sphereStyle}}, 
				{tag: "cam", attrs: {id:"mainCam", style:ctrl.camStyle}}
			]};
		}
  };

  m.mount( S.document.body, App );
	m.render( S.document.head,
		{tag: "rdr", attrs: {init:{ frame: "#solufa", antialias: true}, clearColor:"#000"}, children: [
			m.component(OrbitVp, {cam:"#mainCam"})
		]}
	);
});


function getWebCam( video, index ) {
  var camID = [];

  window.MediaStreamTrack && MediaStreamTrack.getSources( function ( media_sources ) {

    media_sources.forEach( function( media ) {

      if ( media.kind == "video" ) {

        camID.push( media.id );

      }

    } );

    navigator.getUserMedia = navigator.getUserMedia || navigator.webkitGetUserMedia || navigator.mozGetUserMedia || navigator.msGetUserMedia;

    window.URL = window.URL || window.webkitURL;
    navigator.getUserMedia(

      { video: {

        optional: [ { sourceId: camID[ index !== undefined ? index : camID.length - 1 ] } ]

      } },

      function( localMediaStream ) {

        if ( !video ) return;
        video.src = URL.createObjectURL( localMediaStream );

      },

      function( err ) {console.log(err)

        //that.error && that.error( err );

      }

    );

  } );
}
