S( function( m ) {
  var video = document.createElement( "video" );
  getWebCam( video );

  var App = {
		controller: function() {
			return {
        geoInit: function( geo, elem, isInit ) {
          if ( isInit ) return;

          var geometry = elem.coreObject.geometry;

          var faceVertexUvs = geometry.faceVertexUvs[ 0 ];
           for ( i = 0; i < faceVertexUvs.length; i++ ) {
             var uvs = faceVertexUvs[ i ];
             var face = geometry.faces[ i ];
             for ( var j = 0; j < 3; j ++ ) {
               var x = face.vertexNormals[ j ].x;
         	    var y = face.vertexNormals[ j ].y;
         	    var z = face.vertexNormals[ j ].z;

               if (i < faceVertexUvs.length / 2) {
                 var correction = (x == 0 && z == 0) ? 1 : (Math.acos(y) / Math.sqrt(x * x + z * z)) * (2 / Math.PI);
                 uvs[ j ].x = x * (428 / 1920) * correction + (480 / 1920);
                 uvs[ j ].y = z * (428 / 1080) * correction + (600 / 1080);

               } else {
                 var correction = ( x == 0 && z == 0) ? 1 : (Math.acos(-y) / Math.sqrt(x * x + z * z)) * (2 / Math.PI);
                 uvs[ j ].x = -1 * x * (428 / 1920) * correction + (1440 / 1920);
                 uvs[ j ].y = z * (428 / 1080) * correction + (600 / 1080);
               }
             }
           }
        },
				geo: {
					type: "Sphere",
					value: [ 300, 64, 64 ]
				},
				mtl: {
					type: "MeshBasic",
					value: {
            map: {
              type: "video",
              src: video
            },
            side: 2
          }
				},
        sphereStyle: { rotate: [ 0, 0, 0 ] },
				camStyle: { posZ: 5 }
			};
		},
    view: function( ctrl ) {
			return {tag: "scene", attrs: {}, children: [
				{tag: "mesh", attrs: {config: ctrl.geoInit.bind( null, ctrl.geo), geo: ctrl.geo, mtl: ctrl.mtl, style: ctrl.sphereStyle}}, 
				{tag: "cam", attrs: {id:"mainCam", style:ctrl.camStyle}}
			]};
		}
  };

  m.mount( S.document.body, App );
	m.render( S.document.head,
		{tag: "rdr", attrs: {init:{ frame: "#solufa", antialias: true}, clearColor:"#000"}, children: [
			m.component(OrbitVp, {cam:"#mainCam"})
		]}
	);
});


function getWebCam( video, index ) {
  var camID = [];

  window.MediaStreamTrack && MediaStreamTrack.getSources( function ( media_sources ) {

    media_sources.forEach( function( media ) {

      if ( media.kind == "video" ) {

        camID.push( media.id );

      }

    } );

    navigator.getUserMedia = navigator.getUserMedia || navigator.webkitGetUserMedia || navigator.mozGetUserMedia || navigator.msGetUserMedia;

    window.URL = window.URL || window.webkitURL;
    navigator.getUserMedia(

      { video: {

        optional: [ { sourceId: camID[ index !== undefined ? index : camID.length - 1 ] } ]

      } },

      function( localMediaStream ) {

        if ( !video ) return;
        video.src = URL.createObjectURL( localMediaStream );

      },

      function( err ) {console.log(err)

        //that.error && that.error( err );

      }

    );

  } );
}
