S( function( m ) {

  var ua = navigator.userAgent.toUpperCase();
  var isMobile = ua.indexOf('IPHONE') != -1 || (ua.indexOf('ANDROID') != -1 && ua.indexOf('MOBILE') != -1);
  var DURATION = 3000;

  var App = {
    vm: {
      skyGeo: {
        type: "PlaneBuffer",
        value: [ 1500, 1500 ]
      },
      skyMtl: {
        type: "MeshBasic",
        value: {
          color: "#a0d8ef"
        }
      },
      skyStyle: { posY: 500, rotateX: 1.57 },
      lightPos: { pos: [ 0, 10, 10 ] },
      wallStyles: [],
      wallScale: { scale: 10 },
      partsData: [],
      partsBasePos: { posY: .5 },
      partsPos: [
        [ -1.8, 0, -1.6 ],
        [ -2, 0, -1 ],
        [ -1.4, 0, -1.9 ],
        [ -2.2, 0, 1 ],
        [ -1.6, 0, 1.3 ],
        [ -1.7, 0, 0.2 ],
        [ -1.2, 0, -0.5 ],
        [ -1, 0, 0.6 ],
        [ -1.2, 0, 1.7 ],
        [ -0.9, 0, -1.3 ],
        [ -0.1, 0, -2.2 ],
        [ -0.16, 0, -1.4 ],
        [ -0.5, 0, 0.1 ],
        [ 0.4, 0, -1 ],
        [ -0.2, 0, 1.6 ],
        [ 0, 0, 0.6 ],
        [ 0.5, 0, 1.9 ],
        [ 0.8, 0, -0.1 ],
        [ 0.8, 0, 1.1 ],
        [ 1.2, 0, -1.8 ],
        [ 1.8, 0, -1.1 ],
        [ 1.5, 0, -0.1 ],
        [ 1.3, 0, 1.4 ],
        [ 2, 0, 0.8 ],
        [ 0, 0.5, 0 ]
      ],
      camStyle: {pos: [ 0, 20, 3 ], lookAtY: 20 },
      arrowGeo: {
        type: "PlaneBuffer",
        value: [ 1, 1 ]
      },
      arrowMtl: {
        type: "MeshBasic",
        value: {
          map: {
            type: "image",
            src: "./img/arrow.png"
          },
          transparent: true
        }
      },
      panelGeo: {
        type: "PlaneBuffer",
        value: [ 20, 22 ]
      },
      panelMtl: {
        type: "MeshBasic",
        value: {
          map: {
            type: "image",
            src: "./img/kurogen.jpg"
          }
        }
      },
      arrowStyle: { pos: [ 0, -.7, -5 ] },
      init: function() {
        for ( var i = 0; i < 6; i++ ) {
          this.wallStyles.push({
            posY: -i * 7
          });
        }

        for ( var i = 0; i < 25; i++ ) {
          this.partsData.push({
            src: "model/stage2/hahen" + i + ".text",
            style: { pos: this.partsPos[ i ] }
          });
        }
      },
      turned: false,
      falling: false,
      pickSky: function( elem, isInit ) {
        if ( isInit ) return;
        var vm = this;

        var startBtn = document.getElementById( "start" );
        startBtn.style.display = "block";
        startBtn.onclick = function() {
           this.parentNode.parentNode.removeChild( this.parentNode );
           setTimeout( vm._pickSky.bind( vm, elem ), DURATION );
        };
      },
      _pickSky: function( elem, isInit ) {
        if ( isInit ) return;

        var n = 0;
        var virtualArrow = S.document.getElementById( "virtualArrow" );
        var arrow = S.document.getElementById( "arrow" );
        var cam = S.document.getElementById( "cam" );

        var fn = function() {
          arrow.style.pos = virtualArrow.style.worldPos;
          arrow.style.lookAt = cam.style.worldPos;

          if ( ++n % 30 === 0 ) {
            var tmp = elem.pickElementByRatio.apply( elem, !this.isStereo ? [ .5, .5 ] : this.stereoType === "landscape" ? [ .25, .5 ] : [ .5, .25 ] );
            if ( tmp && tmp.id === "sky" ) {
              S.update( fn, false );
              this.moveFace( elem );
              elem = n = null;
              this.arrowMtl.value.map.src = "./img/arrow2.png";
              this.arrowMtl.value.map.needsUpdate = true;
              arrow.setAttribute( "display", false );
            }
          }
        }.bind( this );

        S.update( fn );
      },
      moveFace: function( elem ) {
        var faces = S.document.getElementsByClassName( "face" );

        new TWEEN.Tween({ z: this.faceWrapperStyle.pos[ 2 ] })
        .to({ z: -8.4 }, 1000 )
        .easing(TWEEN.Easing.Bounce.InOut)
        .onUpdate( function() {
          for ( var i = 0; i < faces.length; i++ ) {
            faces[ i ].style.posZ = this.z;
          }
        })
        .onComplete( this.pickBlock.bind( this, elem ) )
        .start();
      },
      pickBlock: function( elem ) {
        setTimeout( this._pickBlock.bind( this, elem ), DURATION );
      },
      _pickBlock: function( elem ) {
        var n = 0;
        var virtualArrow = S.document.getElementById( "virtualArrow" );
        var arrow = S.document.getElementById( "arrow" );
        var cam = S.document.getElementById( "cam" );
        arrow.setAttribute( "display", true );

        var fn = function() {
          arrow.style.pos = virtualArrow.style.worldPos;
          arrow.style.lookAt = cam.style.worldPos;

          if ( ++n % 30 === 0 ) {
            var tmp = elem.pickElementByRatio.apply( elem, !this.isStereo ? [ .5, .5 ] : this.stereoType === "landscape" ? [ .25, .5 ] : [ .5, .25 ] );
            if ( tmp && tmp.className === "block" ) {
              S.update( fn, false );
              elem = n = null;
              this.falling = true;
              this.falldown();
              m.redraw();
            }
          }
        }.bind( this );

        S.update( fn );
      },
      faceRotate: [
        { rotateY: Math.PI / 4 },
        { rotateY: Math.PI / 4 * 3 },
        { rotateY: Math.PI / 4 * 5 },
        { rotateY: Math.PI / 4 * 7 }
      ],
      faceWrapperStyle: { pos: [ 0, 15, -40 ], lookAtY: 20 },
      faceStyle: { scale: 15, rotateX: Math.PI * 7 / 8 },
      falldown: function() {
        var cam = S.document.getElementById( "camWrap" );
        var blocks = S.document.getElementById( "blocks" );
        var camY = cam.style.posY;
        var blocksY = blocks.style.posY;

        new TWEEN.Tween({ camY: camY, blocksY: blocksY })
        .to({ camY: camY - 350, blocksY: blocksY - 35 }, 10500 )
        .easing(TWEEN.Easing.Bounce.Out)
        .onUpdate( function() {
          blocks.style.posY = this.blocksY;
          cam.style.posY = this.camY;
        })
        .start();

        blocks.childNodes.forEach( function( child ) {
          var pos = child.style.pos;
          new TWEEN.Tween({ rotX: 0, rotY: 0, rotZ: 0, posX: pos[ 0 ], posZ: pos[ 2 ] })
          .to({ rotX: Math.random() * Math.PI * 2 - Math.PI, rotY: Math.random() * Math.PI * 2 - Math.PI, rotZ: Math.random() * Math.PI * 2 - Math.PI / 2, posX: 2 * pos[ 0 ], posZ: 2 * pos[ 2 ] }, 10500 )
          .easing(TWEEN.Easing.Bounce.Out)
          .onUpdate( function() {
            child.style.rotate = [ this.rotX, this.rotY, this.rotZ ];
            child.style.pos = [ this.posX, 0, this.posZ ];
          })
          .start();
        });
      },
      stereoType: null,
      stereoChange: function( type ) {
        this.stereoType = type;
      },
      isStereo: +( localStorage.isStereo || 0 ),
      end: function() {
        location.href = "http://www.nhk.or.jp/gendai/schedule/";
      }
    },
    controller: function() {
      App.vm.init();
      S.update( function() {
        TWEEN.update();
      });
    },
    view: function() {
      var vm = App.vm;

      return {tag: "scene", attrs: {}, children: [
        {tag: "mesh", attrs: {id:"sky", geo: vm.skyGeo, mtl: vm.skyMtl, style: vm.skyStyle}}, 
        {tag: "mesh", attrs: {geo: vm.panelGeo, mtl: vm.panelMtl, onclick: vm.end, style:{ pos: [ 0, -330, -10 ]}}}, 
        {tag: "mesh", attrs: {geo: vm.panelGeo, mtl: vm.panelMtl, onclick: vm.end, style:{ pos: [ 0, -330, 10 ], rotateY: Math.PI}}}, 

        {tag: "obj", attrs: {style:vm.wallScale}, children: [
           vm.wallStyles.map( function( style, idx)   {return m.component(ObjMtl, {src:"model/stage2/map_web_0422a.text", style:style});}), 
          m.component(ObjMtl, {src:"model/stage2/map_web_0422b.text"}), 
          m.component(ObjMtl, {src:"model/stage2/map_web_0422c.text"}), 

          {tag: "obj", attrs: {id:"blocks", style: vm.partsBasePos}, children: [
             vm.partsData.map( function(data)  {return m.component(ObjMtl, {class:"block", src: data.src, style: data.style});}) 
          ]}, 

           vm.faceRotate.map( function(rotate)  {return {tag: "obj", attrs: {style: rotate }, children: [{tag: "obj", attrs: {class:"face", style: vm.faceWrapperStyle}, children: [
            m.component(ObjMtl, {src:"model/kao/kao3.text", style: vm.faceStyle})
          ]}]};}) 
        ]}, 

        {tag: "mesh", attrs: {id:"arrow", display: !vm.falling, geo: vm.arrowGeo, mtl: vm.arrowMtl}}, 

        {tag: "obj", attrs: {id:"camWrap", style: vm.camStyle}, children: [
          m.component(JyroSync, {enabled:isMobile}, [
            {tag: "cam", attrs: {id:"cam", style:{ posZ: 10}, fov: vm.isStereo ? 90 : 60}, children: [
              {tag: "obj", attrs: {id:"virtualArrow", style: vm.arrowStyle}}
            ]}
          ])
        ]}, 
        {tag: "light", attrs: {init:{ type: "Dir"}, style: vm.lightPos}}, 
        {tag: "light", attrs: {init:{ type: "Amb"}}}
      ]};
    }
  };

  m.mount( S.document.body, App );

  App.vm.pickSky = App.vm.pickSky.bind( App.vm );
  var initRdr = { frame: "#solufa", antialias: true, preserveDrawingBuffer: false };
  function updateVp() {
    m.render( S.document.head, {tag: "rdr", attrs: {config:App.vm.pickSky, init:initRdr}, children: [
       App.vm.isStereo ? m.component(StereoVp, {cam:"#cam", separation:.3, onchange: App.vm.stereoChange.bind( App.vm)})
        : isMobile ? {tag: "vp", attrs: {cam:"#cam"}} : m.component(OrbitVp, {cam:"#cam", enableZoom:false, enablePan:false, reverse:true})
    ]} );
  }
  updateVp();

  if ( isMobile ) {
    document.getElementById( "switchStereo" ).style.display = "block";
    document.getElementById( "switchStereo" ).addEventListener( "click", function() {
      App.vm.isStereo = 1 - App.vm.isStereo;
      localStorage.isStereo = App.vm.isStereo;
      m.redraw();
      updateVp();
    }, false );
  }

});
